
.model small

rBuffSize	EQU 32
wBuffSize	EQU 64

.stack 100h

.data
    help db "pavadinimas: asd", 10, 13, "Sukure: Dominykas Bernadisius", 10, 13, "Veikimas: Is duomenu failo paimamas tekstas ir tikrinama ar po tasko yra tarpas ir ar sekanti raide yra didzioji ir pagal tai redagoujamas tekstas$"
	ErrorFileOpen	db 10, 13, "Neatsidare duomenu failas!!!.", 10, 13,"$"
	ErrorFileCreate db 10, 13, "Nesusikure rezultatu failas!!!.", 10, 13,"$"
    rFile    	db 32 dup(?)          ;duomenu failas
    wFile		db 'ats.txt', 0		;rezultatu failas
	rBuff		db rBuffSize dup (?)	;skaitymui
	wBuff		db wBuffSize dup (?)	;rasymui
	strLength2   dw ?
	strLength1   dw ?
	DataHandle		dw ?					
	WriteHandle		dw ?	
	new_ln db  13, 10, '$'	

.code

  start:
	MOV	ax, @data		
	MOV	ds, ax			
	
	MOV	bx, 0082h			        	
	
  Parameter:
	MOV	ax, es:[bx]		
	CMP al, 0Dh				;pabaigos simbolis
    JE  parameterRead      
    CMP	ax, "?/"
	JE  found
    MOV [rFile + si], al     
    INC si                  ;skaitliukas
	INC	bx					;paslenku rodykle
	JMP	Parameter			
  parameterRead:
    MOV [rFile + si], 0      ;failo pavadinimas turi baigtis 0
	JMP  begin
  found:
    MOV AH, 09h         
    MOV DX, offset help 
    INT 21h             
    JMP closeProg

  begin:
;Atsidarau duomenu faila

	MOV	ah, 3Dh						
	MOV	al, 00						
	MOV	dx, offset rFile			;failo pavadinimas
	INT	21h							
	JC	ErrorRead			;esant klaidai isspausdinamas erroras ir baigama programa
	MOV	DataHandle, ax

;Atsidarau rasymo faila

	MOV	ah, 3Ch						
	MOV	cx, 0						
	MOV	dx, offset wFile			;failo pavadinimas
	INT	21h							
	JC	ErrorWrite			;esant klaidai isspausdinamas erroras ir baigama programa
	MOV	WriteHandle, ax					;file handle
	JMP Read

;Klaidos

  ErrorRead:
	MOV	ah, 09h				
	LEA	dx, ErrorFileOpen		;erroras
	INT	21h					
	JMP	closeProg
  ErrorWrite:
	MOV	ah, 09h				
	LEA	dx, ErrorFileCreate		;erroras
	INT	21h					
	JMP	closeProg
	
;Nuskaitau duomenis

  Read:
	MOV	bx, DataHandle			;i bx idedu duomenu failo handle
	CALL ReadBuffer			;skaitymo funkcija
	CMP	ax, 0				;ax tai kiek simboliu buvo nuskaityta
    JE	closeWrite			;jeigu ax = 0, tai uzdarau skaitymo faila


;Tvarkau teksta

	MOV	cx, ax
	MOV strLength1, cx
	MOV strLength2, cx
	MOV	si, offset rBuff
	MOV	di, offset wBuff
	
  Do_It:
  
	MOV	dl, [si]
	CMP dl, '.'					;lyginu simboli su tasku
	JNE Keep_Going				;jei nelygu, simboli iskart dedu i wBuff
	MOV dh, [si+1]				;jeigu radau taska tai tikrinu kas eina po tasko
	CMP dh, ' '					;jeigu ne tarpas soku i tikrinima ar didzioji
	JNE If_capital				
	MOV dh, [si+2]				;jeigu buvo tarpas ziuriu ar sekanti raide didzioji
	CMP	dh, 'a'		
	JB	Keep_Going	
	CMP	dh, 'z'		
	JA	Keep_Going	
	SUB	byte ptr [si+2], 32     ;jeigu ne didzioji tai pakeisti didziaja
	
  Keep_Going:
  
	MOV	[di], dl				
	INC	si
	INC	di
	LOOP Do_It
	JMP Finishin
  If_capital:
    
	CMP	dh, 'a'		
	JB	Add_Space		
	CMP	dh, 'z'		
	JA	Add_Space	
	SUB	byte ptr [si+1], 32
	
  Add_Space:
  
    MOV [di], '.'
	INC di
    MOV [di], ' '
	INC di
	INC strLength2
	INC si
	JMP Do_It
	
;Irasau rezultata
  Finishin:
	MOV	cx, strLength2		
	CALL checkOnScreen
	MOV	bx, WriteHandle			
	CALL	writeBuffer	
	CMP strLength1, rBuffSize		
	JE	Read				

;Uzdarau duomenu faila

  closeRead:
	MOV	ah, 3Eh				
	MOV	bx, DataHandle			
	INT	21h			
	
;Uzdarau rasymo faila

  closeWrite:
	MOV	ah, 3Eh				
	MOV	bx, WriteHandle			
	INT	21h				

  closeProg:
	MOV	ah, 4Ch				
	MOV	al, 0				
	INT	21h				

;funkcija nuskaitymui

PROC ReadBuffer

	PUSH	cx
	PUSH	dx

	MOV	ah, 3Fh		
	MOV	cl, rBuffSize
	MOV	ch, 0			
	MOV	dx, offset rBuff	
	INT	21h			

	POP	dx
	POP	cx
	RET

ReadBuffer ENDP

;funkcija irasymui

PROC writeBuffer

	PUSH	dx

	MOV	ah, 40h				
	MOV	dx, offset wBuff
	INT	21h					

	POP	dx
	RET

writeBuffer ENDP

;Spausdinu i ekrana (pasitikrinimui)

PROC checkOnScreen

	PUSH ax
	
	MOV	ah, 40h			
	MOV	bx, 1				
	LEA	dx, wBuff			
	INT 21h
	
	POP ax
	
	RET
	
checkOnScreen ENDP

PROC PrintOneLetter

	PUSH dx
	PUSH ax
	
	mov dl, [di] ; store ascii code of ‘a’ in dl
	mov ah, 2h ; ms-dos character output function
	int 21h ;
	
	POP ax
	POP dx
		
	RET

PrintOneLetter ENDP

PROC Ilgis
	PUSH dx
	PUSH ax
	MOV ah, 9
	MOV dx, offset rBuff
	INT 21h
	POP ax
	POP dx
	RET
Ilgis ENDP

END start

